import { Component, OnInit, Output, EventEmitter } from '@angular/core';
import { ReactiveFormsModule } from '@angular/forms';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
import { DatasetsServiceService } from '../../services/datasets-service.service';

declare var jQuery:any;

@Component({
  selector: 'new-dataset',
  templateUrl: './new-dataset.component.html',
  styleUrls: ['./new-dataset.component.css']
})
export class NewDatasetComponent implements OnInit {


  newdatasetform: FormGroup;

  @Output() idSender: EventEmitter<any> = new EventEmitter<any>();

  constructor(private datasetsService : DatasetsServiceService, private fb: FormBuilder) {

    this.newdatasetform = this.fb.group({
      label: ['', Validators.required ],
      dmp: '',
      uri: '',
      properties: '',
      profile: ''
    });

  }

  ngOnInit() {
    
    //minimum dataset -> {"label": ""}
  }


  store(){
    for(var key in this.newdatasetform.value) {
      if(this.newdatasetform.value[key]=="") 
        this.newdatasetform.value[key] = null;
    }
    this.datasetsService.setDataset(this.newdatasetform.value).subscribe( 
      (data) => {
        jQuery("#newdataset-modal-container").modal("hide");
        this.idSender.emit(data.json().objID);
      }
    );
  
  }


}
