import * as _ from "lodash";
import {Pipe, PipeTransform} from "@angular/core";

@Pipe({
    name: "dmpProfileTableFilter"
})
export class DmpProfileTableFilterPipe implements PipeTransform {

    transform(array: any[], query: string): any {
        
        if (query) {

            return _.filter(array, row => {
                if (row.definition == null) row.definition = "";
                if (row.label == null) row.label = "";
                if (row.id == null) row.id = "";
                return (
                    row.definition.indexOf(query) > -1 ||
                    row.label.indexOf(query) > -1 ||
                    row.id.indexOf(query) > -1
                )
            });
            
        }
        return array;
    }
}