﻿import { FormComponent } from './dataset-profile-form/form/form.component';
import { ModuleWithProviders }  from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { GooggleSignInComponent } from './login/googgle-sign-in/googgle-sign-in.component';
import { DatasetsViewerComponent } from './datasets-viewer/datasets-viewer.component';
import { ProfileEditorComponent } from './bootstrap/profile-editor/profile-editor.component';
import { DmpEditorComponent } from './managers/dmp-editor/dmp-editor.component';
import { DmpProfileEditorComponent } from './managers/dmp-profile-editor/dmp-profile-editor.component';
import { ProjectEditorComponent } from './managers/project-editor/project-editor.component';
import { ServiceEditorComponent } from './managers/service-editor/service-editor.component';
import { RegistryEditorComponent } from './managers/registry-editor/registry-editor.component';
import { OrganisationEditorComponent } from './managers/organisation-editor/organisation-editor.component';
import { ResearcherEditorComponent } from './managers/researcher-editor/researcher-editor.component';
import { DatareposEditorComponent } from './managers/datarepos-editor/datarepos-editor.component';
import { DatasetprofileEditorComponent } from './managers/datasetprofile-editor/datasetprofile-editor.component';

import { MainWindowComponent } from './main-window/main-window.component';



// Route Configuration
export const routes: Routes = [
  
  {
    path: '',
    redirectTo: 'app-root',
    pathMatch: 'full'
  },
  { 
    path: 'datasets', 
    component: DatasetsViewerComponent 
  },
  { 
    path: 'datasetprofiles', 
    component: DatasetprofileEditorComponent 
  },
  { 
    path: 'datarepos', 
    component: DatareposEditorComponent 
  },
  {
    path: 'datasets/profile',
    component: ProfileEditorComponent
    //,data: { title: 'a title' }
  },
  {
    path: 'dmps',
    component: DmpEditorComponent
  },
  {
    path: 'dmpprofiles',
    component: DmpProfileEditorComponent
  },
  {
    path: 'projects',
    component: ProjectEditorComponent
  },
  {
    path: 'services',
    component: ServiceEditorComponent
  },
  {
    path: 'organisations',
    component: OrganisationEditorComponent
  },
  {
    path: 'registries',
    component: RegistryEditorComponent
  },
  {
    path: 'researchers',
    component: ResearcherEditorComponent
  },
  {
    path: 'main',
    component: MainWindowComponent
  },
  {
    path: 'form/:id',
    component: FormComponent
  },
  {
    path: 'form',
    component: FormComponent
  }



];


export const AppRouting: ModuleWithProviders = RouterModule.forRoot(routes);
