import { Component, Input, OnInit, AfterViewChecked, ViewChild } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { TokenService, TokenProvider } from './login/token.service'
import 'rxjs/Rx';
import { Injectable } from '@angular/core';
import {RestBase} from './rest-base';

@Injectable()
export class DatasetProfileService implements OnInit {

  constructor(public restBase: RestBase) {
  }


  ngOnInit(){
    
  }

  fetchAllDatasetProfiles(){
    return this.restBase.get("datasetprofiles/getAll");
  }

  getDatasetProfileById(datasetProfileID){
    return this.restBase.get("admin/get//"+datasetProfileID);
  }

  createDatasetProfile(datasetProfile){
    return this.restBase.post("datasetprofile/create", datasetProfile);
  }

  updateDatasetProfile(datasetProfile){
    return this.restBase.post("datasetprofile/update", datasetProfile);
  }

  delete(datasetProfile){
    return this.restBase.post("datasetprofile/delete", datasetProfile);
  }
  

}