export const TestModel = {
    "sections": [
        {
            "id": "sumData",
            "defaultVisibility": "true",
            "page": "1",
            "title": "1 Data Summary",
            "description": " Fill in the fields to describe your data model ",
            "sections": [],
            "fieldGroups":
            [
                {
                    "id": "dataSummaryGroup",
                    "defaultVisibility": "true",
                    "page": "1",
                    "title": "Data Summary",
                    "description": "",
                    "extendedDescription": "",
                    "compositeFields": [
                        {
                            "multiplicity":{
                                "min":0,
                                "max":3
                            },
                            "fields":
                            [
                                {
                                    "id": "dataSummary",
                                    "defaultVisibility": "true",
                                    "title": "",
                                    "description": "",
                                    "extendedDescription": "",
                                    "viewStyle": "checkBox",
                                    "rules":[
                                        {
                                            "ruleType":"fieldValue",
                                            "target":"metadataStandarsA211",
                                            "ruleStyle":"boolean",
                                            "value":"true",
                                            "valueType":"boolean"
                                        },
                                        {
                                            "ruleType":"fieldValue",
                                            "target":"freeOfChargeGroupCommentA213",
                                            "ruleStyle":"boolean",
                                            "value":"true",
                                            "valueType":"boolean"
                                        },
                                        {
                                            "ruleType":"fieldValue",
                                            "target":"standardisedVocabulariesA212",
                                            "ruleStyle":"boolean",
                                            "value":"true",
                                            "valueType":"boolean"
                                        }
                                    ],
                                    "multiplicity":{
                                        "min":0,
                                        "max":1
                                    }
                                }
                            ]
                        }
                    ]
                }
            ]
        },
        {
            "id": "fairData",
            "ordinal": "2",
            "defaultVisibility": "true",
            "page": "1",
            "title": "2 Fair Data",
            "sections": [
                {
                    "id": "dataMetadata",
                    "defaultVisibility": "true",
                    "page": "1",
                    "title": "2.1 Making data findable, including provisions for metadata",
                    "sections": [],
                    "fieldGroups": [
                        {
                            "id": "FindDataMetadataGroup",
                            "section": "dataMetadata",
                            "defaultVisibility": "true",
                            "page": "1",
                            "title": "Making data findable, including provisions for metadata",
                            "description": "Making data findable, including provisions for metadata",
                            "extendedDescription": "FieldGroup Description",
                            "compositeFields": [
                                {
                                    "fields":
                                    [
                                        {
                                            "id": "useMetadataQ211",
                                            "defaultVisibility": "true",
                                            "title": "Q2.1.1 Will you use metadata to describe the data?",
                                            "description": "User can select from a list of metadata standards. If they cannot find the standard in the list provided then they should choose \"not listed\". Selecting this will result in a field in which the user can insert the URL to the description of the metadata scheme used. A \"comments\" box should exist to allow users to add comments. They may select more than one metadata standard. They may specify more than one URL when selecting \"not listed\". They are also presented with a field in which to specify the location of the metadata service. Users can select the \"no metadata\" button to specify no metadata will be used to describe the data.",
                                            "extendedDescription": "FieldGroup Description",
                                            "viewStyle": "booleanDesicion",
                                            "rules":[
                                                {
                                                    "ruleType":"fieldValue",
                                                    "target":"noMetadata",
                                                    "ruleStyle":"boolean",
                                                    "value":"true",
                                                    "valueType":"boolean"
                                                }
                                            ],
                                            "multiplicity":{
                                                "min":0,
                                                "max":1
                                            }
                                        }
                                    ]
                                },
                                {
                                    "fields":
                                    [
                                        {
                                            "id": "metadataStandarsA211",
                                            "defaultVisibility": "false",
                                            "title": "Metadata standards",
                                            "description": "The data will be described by metadata that follows the metadata standards described in <url1>, <url2>, ? The data will be described by metadata that follows the metadata schema described in <not-listed-url1>, <not-listed-url2>. The metadata will be stored in the service located at <metadata-repo-url>",
                                            "extendedDescription": "",
                                            "viewStyle": "combobox",
                                            "rules":[],
                                            "multiplicity":{
                                                "min":0,
                                                "max":1
                                            }
                                        }]
                                },
                                {
                                    "fields":
                                    [
                                        {
                                            "id": "notlistedA211",
                                            "defaultVisibility": "false",
                                            "title": "Not listed",
                                            "description": "",
                                            "extendedDescription": "",
                                            "viewStyle": "checkBox",
                                            "rules":[
                                                {
                                                    "ruleType":"fieldValue",
                                                    "target":"",
                                                    "ruleStyle":"boolean",
                                                    "value":"",
                                                    "valueType":"boolean"
                                                }
                                            ],
                                            "multiplicity":{
                                                "min":0,
                                                "max":1
                                            }
                                        }]
                                },
                                {
                                    "fields":
                                    [
                                        {
                                            "id": "notlistedUrlA211",
                                            "defaultVisibility": "false",
                                            "title": "Url",
                                            "description": "URL to the description of the metadata scheme used",
                                            "extendedDescription": "",
                                            "viewStyle": "freetext",
                                            "rules":[
                                                {
                                                    "ruleType":"fieldValue",
                                                    "target":"",
                                                    "ruleStyle":"boolean",
                                                    "value":"",
                                                    "valueType":"boolean"
                                                }
                                            ],
                                            "multiplicity":{
                                                "min":0,
                                                "max":1
                                            }
                                        }]
                                },
                                {
                                    "fields":
                                    [
                                        {
                                            "id": "notlistedCommentA211",
                                            "defaultVisibility": "false",
                                            "title": "Comments",
                                            "description": "",
                                            "extendedDescription": "",
                                            "viewStyle": "freetext",
                                            "rules":[
                                                {
                                                    "ruleType":"fieldValue",
                                                    "target":"",
                                                    "ruleStyle":"boolean",
                                                    "value":"",
                                                    "valueType":"boolean"
                                                }
                                            ],
                                            "multiplicity":{
                                                "min":0,
                                                "max":1
                                            }
                                        }]
                                },
                                {
                                    "fields":
                                    [
                                        {
                                            "id": "noMetadata",
                                            "defaultVisibility": "false",
                                            "title": "The data will not be described by any metadata.",
                                            "description": "",
                                            "extendedDescription": "",
                                            "viewStyle": "checkBox",
                                            "rules":[
                                                {
                                                    "ruleType":"fieldValue",
                                                    "target":"",
                                                    "ruleStyle":"boolean",
                                                    "value":"",
                                                    "valueType":"boolean"
                                                }
                                            ],
                                            "multiplicity":{
                                                "min":0,
                                                "max":1
                                            }
                                        }
                                    ]
                                }
                            ]
                        }
                        
                    ]
                }
            ]
        }
    ]
}
