package eu.eudat.cache;


import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import org.springframework.cache.CacheManager;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.cache.support.SimpleCacheManager;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;
import org.springframework.cache.guava.GuavaCache;

import com.google.common.cache.CacheBuilder;



@Component
@EnableCaching
public class ResponsesCache {

	public static long HOW_MANY = 30;
	public static TimeUnit TIME_UNIT = TimeUnit.MINUTES;
	
	
	@Bean
	public CacheManager cacheManager() {
		System.out.print("Loading ResponsesCache...");
		SimpleCacheManager simpleCacheManager = new SimpleCacheManager();
		List<GuavaCache> caches = new ArrayList<GuavaCache>();
		caches.add(new GuavaCache("repositories", CacheBuilder.newBuilder().expireAfterAccess(HOW_MANY, TIME_UNIT).build()));
		caches.add(new GuavaCache("projects", CacheBuilder.newBuilder().expireAfterAccess(HOW_MANY, TIME_UNIT).build()));
		caches.add(new GuavaCache("organisations", CacheBuilder.newBuilder().expireAfterAccess(HOW_MANY, TIME_UNIT).build()));
		caches.add(new GuavaCache("registries", CacheBuilder.newBuilder().expireAfterAccess(HOW_MANY, TIME_UNIT).build()));
		caches.add(new GuavaCache("services", CacheBuilder.newBuilder().expireAfterAccess(HOW_MANY, TIME_UNIT).build()));
		caches.add(new GuavaCache("researchers", CacheBuilder.newBuilder().expireAfterAccess(HOW_MANY, TIME_UNIT).build()));
		simpleCacheManager.setCaches(caches);
		System.out.println("OK");
		return simpleCacheManager;
	}
	
}
