package eu.eudat.controllers;

import eu.eudat.validators.DataManagementPlanTableRequestValidator;
import eu.eudat.validators.ProjectTableRequestValidator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.annotation.InitBinder;

/**
 * Created by ikalyvas on 1/2/2018.
 */
public abstract class BaseController {

    private ApplicationContext springContext;

    public BaseController(ApplicationContext springContext){
        this.springContext = springContext;
    }

    @InitBinder()
    protected void initBinder(WebDataBinder binder) {
        if (binder.getTarget() != null && DataManagementPlanTableRequestValidator.supportsType((binder.getTarget().getClass()))) binder.addValidators(this.springContext.getBean("dataManagementPlanTableRequestValidator",DataManagementPlanTableRequestValidator.class));
        if (binder.getTarget() != null && ProjectTableRequestValidator.supportsType((binder.getTarget().getClass()))) binder.addValidators(this.springContext.getBean("projectTableRequestValidator",ProjectTableRequestValidator.class));
    }
}
