package eu.eudat.dao.databaselayer.service;


import eu.eudat.dao.databaselayer.context.DatabaseContext;
import eu.eudat.entities.DataEntity;
import eu.eudat.queryable.QueryableList;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Set;

/**
 * Created by giannis on 7/17/2017.
 */
@Service("databaseService")
public class DatabaseService<T extends DataEntity<T>> {
    @Autowired
    private DatabaseContext<T> databaseCtx;

    public QueryableList<T> getQueryable(Class<T> tClass) {
        return this.databaseCtx.getQueryable(tClass);
    }

    public QueryableList<T> getQueryable(Class<T> tClass,Set<String> hints) {
        return this.databaseCtx.getQueryable(tClass).setHints(hints);
    }

    public T createOrUpdate(T item, Class<T> tClass) {
        return this.databaseCtx.createOrUpdate(item, tClass);
    }

    public Long count(Class<T> tClass){return this.databaseCtx.count(tClass);}
}
