package eu.eudat.dao.entities;

import java.util.List;
import java.util.UUID;

import eu.eudat.dao.Dao;
import eu.eudat.entities.DMP;
import eu.eudat.entities.Dataset;
import eu.eudat.entities.UserInfo;
import eu.eudat.entities.responses.IDLabelPair;
import eu.eudat.models.criteria.DataManagementPlanCriteria;
import eu.eudat.models.datasetwizard.DatasetWizardAutocompleteRequest;
import eu.eudat.models.dmp.DataManagementPlanTableRequest;
import eu.eudat.queryable.QueryableList;
import org.springframework.stereotype.Service;

public interface DMPDao {

	QueryableList<DMP> getWithCriteria(DataManagementPlanCriteria criteria);

	QueryableList<DMP> getUserDmps(DatasetWizardAutocompleteRequest datasetWizardAutocompleteRequest, UserInfo userInfo);

	DMP createOrUpdate(DMP item);

	DMP find(UUID id);

	Long count();

}