package eu.eudat.dao.entities;

import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

import javax.persistence.Query;
import javax.persistence.TypedQuery;

import eu.eudat.dao.JpaDao;
import eu.eudat.dao.databaselayer.service.DatabaseService;
import eu.eudat.entities.Dataset;
import eu.eudat.entities.DatasetProfile;
import eu.eudat.entities.responses.IDLabelPair;
import eu.eudat.models.criteria.DatasetCriteria;
import eu.eudat.models.criteria.DatasetProfileCriteria;
import eu.eudat.queryable.QueryableList;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component("datasetProfileDao")
public class DatasetProfileDaoImpl implements DatasetProfileDao {

	@Autowired
	DatabaseService<DatasetProfile> databaseService;

	@Override
	public QueryableList<DatasetProfile> getWithCriteria(DatasetProfileCriteria criteria) {
		QueryableList<DatasetProfile> query = databaseService.getQueryable(DatasetProfile.class);
		if(criteria.getLike()!=null&&!criteria.getLike().isEmpty())query.where((builder, root) -> builder.like(root.get("label"),"%"+criteria.getLike()+"%"));
		return query;
	}


	@Override
	public DatasetProfile createOrUpdate(DatasetProfile item) {
		return this.databaseService.createOrUpdate(item,DatasetProfile.class);
	}

	@Override
	public DatasetProfile find(UUID id) {
		return databaseService.getQueryable(DatasetProfile.class).where((builder, root) -> builder.equal(root.get("id"),id)).toList().get(0);
	}

	@Override
	public Long count() {
		return null;
	}

	@Override
	public QueryableList<DatasetProfile> getAll() {
		return databaseService.getQueryable(DatasetProfile.class);
	}
}
