package eu.eudat.dao.entities;

import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import eu.eudat.models.criteria.Criteria;
import org.hibernate.query.Query;

import eu.eudat.dao.JpaDao;
import eu.eudat.entities.Organisation;
import eu.eudat.entities.responses.IDLabelPair;
import org.springframework.stereotype.Component;

@Component("organisationDao")
public class OrganisationDaoImpl extends JpaDao<Organisation, UUID> implements OrganisationDao {

	public Organisation loadDetails(Organisation t) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<UUID> listAllIDs() {
		String queryString = "SELECT organisation.id FROM Organisation organisation";
		TypedQuery<UUID> typedQuery = entityManager.createQuery(queryString, UUID.class);
		return typedQuery.getResultList();
	}
	
	@Override
	public List<IDLabelPair> listAllIDsLabels() {
		String queryString = "SELECT organisation.id, organisation.label FROM Organisation organisation";
		Query query = (Query) entityManager.createQuery(queryString);
		List<Object[]> rows = query.list();
		return rows.stream().map(row -> {
			return new IDLabelPair(row[0].toString(), row[1].toString());
		})
		.collect(Collectors.toList());
	}


	@Override
	public List<Organisation> listBy(Criteria<Organisation> criteria) {
		CriteriaBuilder criteriaBuilder = entityManager.getCriteriaBuilder();
		CriteriaQuery<Organisation> criteriaQuery = criteriaBuilder .createQuery(Organisation.class);
		Root<Organisation> root = criteriaQuery.from(Organisation.class);
		criteriaQuery.where(criteriaBuilder.equal(root.get("reference"), criteria.getLike()));
		TypedQuery<Organisation> typedQuery = entityManager.createQuery(criteriaQuery);
		return typedQuery.getResultList();
	}
	
	
}
