package eu.eudat.dao.entities;

import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.query.Query;

import eu.eudat.dao.JpaDao;
import eu.eudat.entities.Registry;
import eu.eudat.entities.responses.IDLabelPair;
import eu.eudat.models.criteria.Criteria;
import org.springframework.stereotype.Component;

@Component("registryDao")
public class RegistryDaoImpl extends JpaDao<Registry, UUID> implements RegistryDao {

	public Registry loadDetails(Registry t) {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public List<UUID> listAllIDs() {
		String queryString = "SELECT registry.id FROM Registry registry";
		TypedQuery<UUID> typedQuery = entityManager.createQuery(queryString, UUID.class);
		return typedQuery.getResultList();
	}
	
	
	@Override
	public List<IDLabelPair> listAllIDsLabels() {
		String queryString = "SELECT registry.id, registry.label FROM Registry registry";
		Query query = (Query) entityManager.createQuery(queryString);
		List<Object[]> rows = query.list();
		return rows.stream().map(row -> {
			return new IDLabelPair(row[0].toString(), row[1].toString());
		})
		.collect(Collectors.toList());
	}

	@Override
	public List<Registry> listBy(Criteria<Registry> criteria) {
		CriteriaBuilder criteriaBuilder = entityManager.getCriteriaBuilder();
		CriteriaQuery<Registry> criteriaQuery = criteriaBuilder .createQuery(Registry.class);	
		Root<Registry> root = criteriaQuery.from(Registry.class);
		criteriaQuery.where(criteriaBuilder.equal(root.get("reference"), criteria.getLike()));
		TypedQuery<Registry> typedQuery = entityManager.createQuery(criteriaQuery);
		return typedQuery.getResultList();
	}

	

}
