package eu.eudat.entities;

import javax.persistence.*;
import java.util.Date;
import java.util.UUID;

/**
 * Created by ikalyvas on 12/15/2017.
 */
@Entity
@Table(name="\"UserToken\"")
public class UserToken implements DataEntity<UserToken>{

    private static final long serialVersionUID = 1225151430484658395L;

    @Id
    @Column(name = "\"Token\"", updatable = false, nullable = false, columnDefinition = "BINARY(16)")
    private UUID token;

    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "\"UserId\"", nullable = false)
    private UserInfo user;

    @Column(name = "\"IssuedAt\"", nullable = false)
    private Date issuedAt = null;


    @Column(name = "\"ExpiresAt\"", nullable = false)
    private Date expiresAt = null;

    public UUID getToken() {
        return token;
    }

    public void setToken(UUID token) {
        this.token = token;
    }

    public UserInfo getUser() {
        return user;
    }

    public void setUser(UserInfo user) {
        this.user = user;
    }

    public Date getIssuedAt() {
        return issuedAt;
    }

    public void setIssuedAt(Date issuedAt) {
        this.issuedAt = issuedAt;
    }

    public Date getExpiresAt() {
        return expiresAt;
    }

    public void setExpiresAt(Date expiresAt) {
        this.expiresAt = expiresAt;
    }

    @Override
    public void update(UserToken entity) {

    }

    @Override
    public Object[] getKeys() {
        return new UUID[]{this.token == null ? null : this.token};
    }
}
