package eu.eudat.managers;

import java.util.Date;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.dataformat.xml.XmlMapper;

import eu.eudat.entities.DatasetProfileViewstyle;
import eu.eudat.entities.xmlmodels.datasetprofiledefinition.ViewStyleModel;
import eu.eudat.models.admin.components.datasetprofile.FieldSet;
import eu.eudat.models.admin.composite.DatasetProfile;
import eu.eudat.utilities.builders.ModelBuilder;
import eu.eudat.utilities.builders.XmlBuilder;
import eu.eudat.utilities.helpers.ModelBuilderCollector;

public class AdminManager {

	
	public static eu.eudat.entities.DatasetProfile generateViewStyleDefinition(DatasetProfile profile){
		ViewStyleModel viewStyleModel = new ViewStyleModel();
		viewStyleModel.setSections(new ModelBuilder().toViewStyleDefinition(profile.getSections(), eu.eudat.entities.xmlmodels.datasetprofiledefinition.Section.class));
		Document viewStyleDoc = XmlBuilder.getDocument();
		Element elementViewStyle = viewStyleModel.toXml(viewStyleDoc);
		viewStyleDoc.appendChild(elementViewStyle);
		String xml  = XmlBuilder.generateXml(viewStyleDoc);
		
		eu.eudat.entities.DatasetProfile datasetProfile = new eu.eudat.entities.DatasetProfile();
		datasetProfile.setDefinition(xml);
		datasetProfile.setLabel(profile.getLabel());
		datasetProfile.setStatus((short)1);
		datasetProfile.setCreated(new Date());
		return datasetProfile;
	}
	
	public static eu.eudat.models.admin.composite.DatasetProfile generateDatasetProfileModel(eu.eudat.entities.DatasetProfile profile){
		Document viewStyleDoc = XmlBuilder.fromXml(profile.getDefinition());
		Element root = (Element)viewStyleDoc.getDocumentElement();
		eu.eudat.entities.xmlmodels.datasetprofiledefinition.ViewStyleModel viewstyle= new eu.eudat.entities.xmlmodels.datasetprofiledefinition.ViewStyleModel().fromXml(root);
		
		Document profileDoc = XmlBuilder.fromXml(profile.getDefinition());
		root = (Element)profileDoc.getDocumentElement();

		eu.eudat.models.admin.composite.DatasetProfile datasetprofile = new eu.eudat.models.admin.composite.DatasetProfile();
		datasetprofile.buildProfile(viewstyle);
		
		return datasetprofile;
	}
}
