package eu.eudat.models.admin.components.datasetprofile;

import eu.eudat.entities.xmlmodels.modeldefinition.*;
import eu.eudat.utilities.ModelDefinition;
import org.apache.commons.lang3.RandomStringUtils;

import eu.eudat.models.components.commons.DefaultValue;
import eu.eudat.models.components.commons.Multiplicity;
import eu.eudat.models.components.commons.ViewStyle;
import eu.eudat.models.components.commons.Visibility;
import eu.eudat.utilities.ViewStyleDefinition;
import eu.eudat.utilities.builders.ModelBuilder;

public class Field implements ViewStyleDefinition<eu.eudat.entities.xmlmodels.datasetprofiledefinition.Field>,Comparable{
	private String id;
	private Integer ordinal;
	private String value;
	private ViewStyle viewStyle;
	private String datatype;
	private int page;
	private DefaultValue defaultValue;
	private Object data;
	private Visibility visible;	
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	
	public int getOrdinal(){
		return ordinal;
	}
	
	public void setOrdinal(int ordinal){
		this.ordinal = ordinal;
	}
		public String getValue() {
		return value;
	}
	public void setValue(String value) {
		this.value = value;
	}
	public ViewStyle getViewStyle() {
		return viewStyle;
	}
	public void setViewStyle(ViewStyle viewStyle) {
		this.viewStyle = viewStyle;
	}
	public int getPage() {
		return page;
	}
	public void setPage(int page) {
		this.page = page;
	}		
		
	public DefaultValue getDefaultValue() {
		return defaultValue;
	}
	public void setDefaultValue(DefaultValue defaultValue) {
		this.defaultValue = defaultValue;
	}
	public String getDatatype() {
		return datatype;
	}
	public void setDatatype(String datatype) {
		this.datatype = datatype;
	}
	

	public Object getData() {
		return data;
	}
	public void setData(Object data) {
		this.data = data;
	}
	
	
	public Visibility getVisible() {
		return visible;
	}
	public void setVisible(Visibility visible) {
		this.visible = visible;
	}

	@Override
	public eu.eudat.entities.xmlmodels.datasetprofiledefinition.Field toDatabaseDefinition(eu.eudat.entities.xmlmodels.datasetprofiledefinition.Field field) {
		if(this.id == null||this.id.isEmpty())this.id = "field_"+RandomStringUtils.random(5, true, true);

		field.setId(this.id);
		field.setOrdinal(this.ordinal);
		field.setViewStyle(this.viewStyle);
		field.setData(new ModelBuilder().toFieldData(data, this.viewStyle.getRenderStyle()));
		field.setVisible(this.visible);
		field.setDefaultValue(this.defaultValue);
		return field;
	}
	@Override
	public void fromDatabaseDefinition(eu.eudat.entities.xmlmodels.datasetprofiledefinition.Field item) {
		this.id = item.getId();
		this.ordinal = item.getOrdinal();
		this.viewStyle = item.getViewStyle();
		this.data = item.getData();
		this.visible = item.getVisible();
		this.defaultValue = item.getDefaultValue();
	}
	@Override
	public int compareTo(Object o) {
		return this.ordinal.compareTo(((Field)o).ordinal);
	}			
	
	
}
