package eu.eudat.models.components.commons.datafield;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class WordListData extends ComboBoxData<WordListData>{
	private List<Option> options;
	
	public List<Option> getOptions() {
		return options;
	}
	public void setOptions(List<Option> options) {
		this.options = options;
	}
	
	
	@Override
	public Element toXml(Document doc) {
		Element root = super.toXml(doc);	
		Element element = doc.createElement("options");
		if(this.options!=null){
			for(Option option : this.options){
				element.appendChild(option.toXml(doc));
			}
		}
		root.appendChild(element);
		return root;
	}
	@Override
	public WordListData fromXml(Element item) {
		super.fromXml(item);
		this.options = new LinkedList<>();
		Element optionsElement = (Element)item.getElementsByTagName("options").item(0);

		if(optionsElement!=null){
			NodeList optionElements = optionsElement.getChildNodes();
			for (int temp = 0; temp < optionElements.getLength(); temp++) {
				Node optionElement = optionElements.item(temp);				
				if (optionElement.getNodeType() == Node.ELEMENT_NODE) {
					this.options.add(new Option().fromXml((Element)optionElement));
				}
			}
		}
		return this;
	}
	@Override
	public WordListData fromData(Object data) {
		super.fromData(data);
		this.options = new LinkedList();

		if(data!=null){
			List<Map<String,String>> options = ((Map<String,List<Map<String,String>>>)data).get("options");		
			if(options!=null){
					for(Map<String,String> map : options){
						Option newOption = new Option();
						newOption.setLabel(map.get("label"));
						newOption.setValue(map.get("value"));
						this.options.add(newOption);
					}
			}
		}
		
		return this;
	}
	@Override
	public Object toData() {
		// TODO Auto-generated method stub
		return null;
	}
	
	
}
