package eu.eudat.models.dataset;

import eu.eudat.models.DataModel;
import eu.eudat.utilities.helpers.LabelGenerator;

import java.util.Date;

public class DataRepository implements DataModel<eu.eudat.entities.DataRepository>,LabelGenerator{
	private String pid;
    private String name;
    private String uri;	
	
	public String getPid() {
		return pid;
	}

	public void setPid(String pid) {
		this.pid = pid;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getUri() {
		return uri;
	}

	public void setUri(String uri) {
		this.uri = uri;
	}

	public void fromDataModel(eu.eudat.entities.DataRepository entity){
		this.pid = entity.getReference();
		this.name = entity.getLabel();
		this.uri = entity.getUri();
	}
	
	public eu.eudat.entities.DataRepository toDataModel(){
		eu.eudat.entities.DataRepository entity = new eu.eudat.entities.DataRepository();
		entity.setReference(this.pid);
		entity.setLabel(this.name);
		entity.setUri(this.uri);
		entity.setCreated(new Date());
		entity.setModified(new Date());
		entity.setStatus((short)0);
		return entity;
	}

	@Override
	public String generateLabel() {
		return this.getName();
	}
}
