package eu.eudat.models.dmp;

import eu.eudat.models.DataModel;
import eu.eudat.utilities.helpers.LabelGenerator;

import java.util.Date;

public class Researcher implements DataModel<eu.eudat.entities.Researcher>,LabelGenerator {
    private String label;
    private String name;
    private String id;
    private int status;

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    @Override
    public void fromDataModel(eu.eudat.entities.Researcher entity) {
        this.id = entity.getReference();
        this.label = entity.getUri();
        this.name = entity.getLabel();
        this.status = entity.getStatus();
    }

    @Override
    public eu.eudat.entities.Researcher toDataModel() {
        eu.eudat.entities.Researcher researcher = new eu.eudat.entities.Researcher();
        researcher.setReference(this.id);
        researcher.setLabel(this.name);
        researcher.setUri(this.label);
        researcher.setCreated(new Date());
        researcher.setStatus((short)this.status);
        return researcher;
    }

    @Override
    public String generateLabel() {
        return this.getName();
    }
}
