package eu.eudat.models.listingmodels;

import eu.eudat.entities.*;
import eu.eudat.entities.DataRepository;
import eu.eudat.entities.Dataset;
import eu.eudat.entities.Organisation;
import eu.eudat.entities.Registry;
import eu.eudat.entities.Researcher;
import eu.eudat.models.DataModel;
import eu.eudat.models.dataset.*;
import eu.eudat.models.dataset.Service;
import eu.eudat.models.dmp.*;
import eu.eudat.utilities.builders.DomainModelConverter;
import eu.eudat.utilities.helpers.LabelBuilder;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.util.Date;
import java.util.Set;
import java.util.UUID;
import java.util.stream.Collectors;

/**
 * Created by ikalyvas on 12/19/2017.
 */
public class DatasetListingModel implements DataModel<Dataset> {
    private String id;
    private String label;
    private String dmp;
    private String profile;
    private String dataRepositories;
    private String registries;
    private String services;
    private String status;
    private String created;
    private String description;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getDmp() {
        return dmp;
    }

    public void setDmp(String dmp) {
        this.dmp = dmp;
    }

    public String getProfile() {
        return profile;
    }

    public void setProfile(String profile) {
        this.profile = profile;
    }

    public String getDataRepositories() {
        return dataRepositories;
    }

    public void setDataRepositories(String dataRepositories) {
        this.dataRepositories = dataRepositories;
    }

    public String getRegistries() {
        return registries;
    }

    public void setRegistries(String registries) {
        this.registries = registries;
    }

    public String getServices() {
        return services;
    }

    public void setServices(String services) {
        this.services = services;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getCreated() {
        return created;
    }

    public void setCreated(String created) {
        this.created = created;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Override
    public void fromDataModel(Dataset entity) throws InstantiationException, IllegalAccessException {
        this.id = entity.getId().toString();
        this.label = entity.getLabel();
        this.created = entity.getCreated().toString();
        this.dmp = entity.getDmp()!=null? entity.getDmp().getLabel():"";
        this.profile = entity.getProfile()!=null? entity.getProfile().getLabel():"";
        this.description = entity.getDescription();
        this.status = ""+entity.getStatus();
        this.registries = LabelBuilder.getLabel(new DomainModelConverter<Registry, eu.eudat.models.dataset.Registry>().fromDataModel(entity.getRegistries().stream().collect(Collectors.toList()), eu.eudat.models.dataset.Registry.class));
        this.dataRepositories = LabelBuilder.getLabel(new DomainModelConverter<eu.eudat.entities.DataRepository, eu.eudat.models.dataset.DataRepository>().fromDataModel(entity.getDataRepositories().stream().collect(Collectors.toList()), eu.eudat.models.dataset.DataRepository.class));
        this.services = LabelBuilder.getLabel(new DomainModelConverter<eu.eudat.entities.Service, eu.eudat.models.dataset.Service>().fromDataModel(entity.getServices().stream().collect(Collectors.toList()), Service.class));
    }

    @Override
    public Dataset toDataModel() {
        return null;
    }
}
