package eu.eudat.models.user.components.datasetprofile;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import eu.eudat.entities.xmlmodels.modeldefinition.*;
import eu.eudat.models.components.commons.DefaultValue;
import eu.eudat.models.components.commons.Multiplicity;
import eu.eudat.models.components.commons.ViewStyle;
import eu.eudat.models.components.commons.Visibility;
import eu.eudat.models.user.composite.PropertiesModelBuilder;
import eu.eudat.utilities.ModelDefinition;
import eu.eudat.utilities.ViewStyleDefinition;
import eu.eudat.utilities.builders.ModelBuilder;

public class Field implements Comparable,PropertiesModelBuilder,ViewStyleDefinition<eu.eudat.entities.xmlmodels.datasetprofiledefinition.Field>{
	private String id;
	private Integer ordinal;
	private String value;
	private ViewStyle viewStyle;
	private String datatype;
	private int page;
	private DefaultValue defaultValue;
	private Multiplicity multiplicity;
	private Object data;
	private List<Field> multiplicityItems;
	private Visibility visible;
	public List<Field> getMultiplicityItems() {
		return multiplicityItems;
	}
	public void setMultiplicityItems(List<Field> multiplicityItems) {
		this.multiplicityItems = multiplicityItems;
	}
	public void setOrdinal(Integer ordinal) {
		this.ordinal = ordinal;
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	
	public int getOrdinal(){
		return ordinal;
	}
	
	public void setOrdinal(int ordinal){
		this.ordinal = ordinal;
	}
	public String getValue() {
		return value;
	}
	public void setValue(String value) {
		this.value = value;
	}
	public ViewStyle getViewStyle() {
		return viewStyle;
	}
	public void setViewStyle(ViewStyle viewStyle) {
		this.viewStyle = viewStyle;
	}
	public int getPage() {
		return page;
	}
	public void setPage(int page) {
		this.page = page;
	}		
		
	public DefaultValue getDefaultValue() {
		return defaultValue;
	}
	public void setDefaultValue(DefaultValue defaultValue) {
		this.defaultValue = defaultValue;
	}
	public String getDatatype() {
		return datatype;
	}
	public void setDatatype(String datatype) {
		this.datatype = datatype;
	}
	
	public Multiplicity getMultiplicity() {
		return multiplicity;
	}
	public void setMultiplicity(Multiplicity multiplicity) {
		this.multiplicity = multiplicity;
	}		
	
	public Object getData() {
		return data;
	}
	public void setData(Object data) {
		this.data = data;
	}

	public Visibility getVisible() {
		return visible;
	}

	public void setVisible(Visibility visible) {
		this.visible = visible;
	}

	public Field cloneForMultiplicity(String key, Map<String, Object> properties){
		Field newField = new Field();
		newField.id = key;
		newField.ordinal = this.ordinal;
		newField.value = (String)properties.get(key);
		newField.viewStyle = this.viewStyle;
		newField.datatype = this.datatype;
		newField.page = this.page;
		newField.defaultValue = this.defaultValue;
		newField.data = this.data;
		
		return newField;
	}

	@Override
	public eu.eudat.entities.xmlmodels.datasetprofiledefinition.Field toDatabaseDefinition(eu.eudat.entities.xmlmodels.datasetprofiledefinition.Field field) {
		field.setId(this.id);
		field.setOrdinal(this.ordinal);
		field.setViewStyle(this.viewStyle);
		field.setData(new ModelBuilder().toFieldData(data, this.viewStyle.getRenderStyle()));
		field.setDefaultValue(this.defaultValue);
		field.setVisible(this.visible);
		return field;
	}
	@Override
	public void fromDatabaseDefinition(eu.eudat.entities.xmlmodels.datasetprofiledefinition.Field item) {
		this.id = item.getId();
		this.ordinal = item.getOrdinal();
		this.viewStyle = item.getViewStyle();
		this.data = item.getData();
		this.defaultValue = item.getDefaultValue();
		this.visible= item.getVisible();
	}
	@Override
	public void fromJsonObject(Map<String, Object> properties) {
		this.value = (String)properties.get(this.id);
		this.multiplicityItems = new LinkedList<Field>();
		List<String> compositeKeys =  properties.keySet().stream().filter(keys->keys.startsWith("multiple_"+this.getId())).collect(Collectors.toList());
		for (String key : compositeKeys) {
			this.multiplicityItems.add(this.cloneForMultiplicity(key, properties));
		}
		
	}
	@Override
	public int compareTo(Object o) {
		return this.ordinal.compareTo(((Field)o).getOrdinal());
	}
	@Override
	public void fromJsonObject(Map<String, Object> properties, String path) {
		this.value = (String)properties.get(path);
	}				

}