package eu.eudat.models.user.composite;

import eu.eudat.utilities.builders.ModelBuilder;
import eu.eudat.utilities.helpers.ModelBuilderCollector;

import java.util.List;
import java.util.Map;

import eu.eudat.models.user.components.datasetprofile.*;
import eu.eudat.models.user.components.commons.Rule;

public class DatasetProfile implements PropertiesModelBuilder{
	private List<Section> sections;
	private List<Rule> rules;
	private int status;
	public List<Section> getSections() {
		return sections;
	}

	public void setSections(List<Section> sections) {
		this.sections = sections;
	}	
	
	
	public List<Rule> getRules() {
		return rules;
	}

	public void setRules(List<Rule> rules) {
		this.rules = rules;
	}		

	public int getStatus() {
		return status;
	}

	public void setStatus(int status) {
		this.status = status;
	}

	public void buildProfile( eu.eudat.entities.xmlmodels.datasetprofiledefinition.ViewStyleModel viewStyle){
		this.sections = new ModelBuilder().fromViewStyleDefinition(viewStyle.getSections(), Section.class);
		this.rules = ModelBuilderCollector.collectRules(viewStyle.getSections());
	}

	@Override
	public void fromJsonObject(Map<String, Object> properties) {
		this.sections.forEach(item->item.fromJsonObject(properties));
		
	}

	@Override
	public void fromJsonObject(Map<String, Object> properties, String index) {
		// TODO Auto-generated method stub
		
	}
	
}
