package eu.eudat.queryable;


import eu.eudat.entities.DataEntity;
import eu.eudat.queryable.predicates.OrderByPredicate;
import eu.eudat.queryable.predicates.SelectPredicate;
import eu.eudat.queryable.predicates.SinglePredicate;

import javax.xml.crypto.Data;
import java.util.List;
import java.util.Set;

public interface QueryableList<T extends DataEntity<T>>  {
    QueryableList<T> where(SinglePredicate<T> predicate);

    <R> List<R> select(SelectPredicate<T, R> predicate);

    List<T> toList();

    QueryableList<T> skip(Integer offset);

    QueryableList<T> take(Integer length);

    QueryableList<T> distinct();

    QueryableList<T> orderByAsc(OrderByPredicate<T> predicate);
    QueryableList<T> orderByDesc(OrderByPredicate<T> predicate);
    QueryableList<T> setHints(Set<String> hints);
    void withHint(String hint);
    Long count();
}
