package eu.eudat.validators;

import eu.eudat.models.dmp.DataManagementPlanTableRequest;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

/**
 * Created by ikalyvas on 12/22/2017.
 */
@Component("dataManagementPlanTableRequestValidator")
public class DataManagementPlanTableRequestValidator implements Validator {
    @Override
    public boolean supports(Class<?> aClass) {
        return DataManagementPlanTableRequest.class.equals(aClass);
    }

    @Override
    public void validate(Object obj, Errors errors) {
        DataManagementPlanTableRequest dataManagementPlanTableRequest = (DataManagementPlanTableRequest) obj;
        if(dataManagementPlanTableRequest.getOffset()<0){
            errors.rejectValue("offset", "datamanagementplanrequest.offset.negative");
        }
        if(dataManagementPlanTableRequest.getLength()<0){
            errors.rejectValue("length", "datamanagementplanrequest.length.negative");
        }
    }

    public static boolean supportsType(Class<?> clazz) {
        return DataManagementPlanTableRequest.class.equals(clazz);
    }
}
