import { BaseModel } from './BaseModel';
import { FormGroup } from '@angular/forms';
import { FormGenerator } from './interfaces/FormGenerator';
import { Serializable } from './interfaces/Serializable';
export class Multiplicity extends BaseModel implements Serializable<Multiplicity>, FormGenerator<FormGroup>{
    public min: number;
    public max: number;

    fromJSONObject(item: any): Multiplicity {
        this.min = item.min;
        this.max = item.max;
        return this;
    }

    buildForm(): FormGroup {
        let formGroup = this.formBuilder.group({
            min: [this.min],
            max: [this.max]

        });
        return formGroup;
    }
}