import { Component, OnInit, Input } from '@angular/core';
import { FormControl, FormGroup, NgForm, FormArray, AbstractControl } from '@angular/forms';
import { BaseCriteriaErrorModel } from '../../../../models/criteria/BaseCriteriaErrorModel';

@Component({
    selector: 'base-criteria-component',
    template: '',
    providers: [

    ]
})

export class BaseCriteriaComponent implements OnInit {

    public refreshCallback: Function = null;
    public baseErrorModel: BaseCriteriaErrorModel = new BaseCriteriaErrorModel();

    constructor(baseErrorModel: BaseCriteriaErrorModel) {
        this.baseErrorModel = baseErrorModel;
    }

    ngOnInit() {
    }

    setRefreshCallback(callback: Function): void {
        this.refreshCallback = callback;
    }

    public setErrorModel(errorModel: BaseCriteriaErrorModel) {
        Object.keys(errorModel).forEach(item => {
            (<any>this.baseErrorModel)[item] = (<any>errorModel)[item];
        })
    }

    public clearErrorModel() {
        Object.keys(this.baseErrorModel).forEach(item => {
            (<any>this.baseErrorModel)[item] = '';
        })
    }

}
