import { TranslateService } from '@ngx-translate/core';
import { Component, OnInit } from '@angular/core';
import { FormControl, FormGroup, FormBuilder, Validators } from '@angular/forms';
import { BaseCriteriaComponent } from '../base/base-criteria.component';
import { ValidationContext, Validation } from '../../../../utilities/validators/ValidationContext';
import { BackendErrorValidator } from '../../../../utilities/validators/BackendErrorValidator';
import { DatasetCriteriaErrorModel } from '../../../../models/criteria/dataset/DatasetCriteriaErrorModel';
import { DatasetCriteria } from '../../../../models/criteria/dataset/DatasetCriteria';

@Component({
	selector: 'app-datasets-criteria-component',
	templateUrl: './datasets-criteria.component.html',
	styleUrls: ['./datasets-criteria.component.scss'],
	providers: [
	]
})

export class DatasetCriteriaComponent extends BaseCriteriaComponent implements OnInit {

	// public form: ProjectType;
	// public formStatus: ProjectStatus;
	public criteria: DatasetCriteria= new DatasetCriteria();

	statuses = [
		{value: '0', viewValue: 'Active'},
		{value: '1', viewValue: 'Inactive'}
	  ];

	constructor(
		public language: TranslateService,
		public formBuilder: FormBuilder
	) {
		super(new DatasetCriteriaErrorModel());
	}

	ngOnInit() {
		super.ngOnInit();
		if (this.criteria == null) { this.criteria = new DatasetCriteria(); }
	}

	setCriteria(criteria: DatasetCriteria): void {
		this.criteria = criteria;
	}

	onCallbackError(error: any) {
		this.setErrorModel(error.error);
	}

	controlModified(): void {
		this.clearErrorModel();
		if (this.refreshCallback != null &&
			(this.criteria.like == null || this.criteria.like.length == 0 || this.criteria.like.length > 2)
		) {
			this.refreshCallback();
		}
	}
}
