import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { NavigationComponent } from './components/navigation/navigation.component';
import { SnackBarNotificationComponent } from './components/notificaiton/snack-bar-notification.component';
import { MaterialModule } from './material/material.module';
import { TranslateModule } from '@ngx-translate/core';
import { ProjectCriteriaComponent } from './components/criteria/projects/projects-criteria.component';
import { DatasetCriteriaComponent } from './components/criteria/datasets/datasets-criteria.component';
import { FormsModule } from '@angular/forms';
import { DataManagementPlanCriteriaComponent } from './components/criteria/data-management-plan/dmp-criteria.component';

@NgModule({
	imports: [
		CommonModule,
		RouterModule,
		MaterialModule,
		TranslateModule,
		FormsModule
	],

	declarations: [
		NavigationComponent,
		SnackBarNotificationComponent,
		ProjectCriteriaComponent,
		DatasetCriteriaComponent,
		DataManagementPlanCriteriaComponent
	],

	exports: [
		NavigationComponent,
		SnackBarNotificationComponent,
		ProjectCriteriaComponent,
		DatasetCriteriaComponent,
		DataManagementPlanCriteriaComponent
	],
	entryComponents: [
	]
})

export class SharedModule { }
