var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input } from "@angular/core";
import { AuthService } from "../core/services/auth.service";
import { ActivatedRoute, Router } from "@angular/router";
var UnauthorizedComponent = (function () {
    function UnauthorizedComponent(authService, route, router) {
        this.authService = authService;
        this.route = route;
        this.router = router;
    }
    UnauthorizedComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var returnUrl = this.route.snapshot.queryParams['returnUrl'] || '/';
        var principal = this.authService.current();
        if (!principal) {
            this.router.navigate(['/login'], { queryParams: { returnUrl: returnUrl } });
        }
        else {
            this.authService.me().subscribe(function (principal) {
                if (!principal)
                    _this.router.navigate(['/login'], { queryParams: { returnUrl: returnUrl } });
            }, function (err) { return console.error('An error occurred', err); });
        }
    };
    return UnauthorizedComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", String)
], UnauthorizedComponent.prototype, "message", void 0);
UnauthorizedComponent = __decorate([
    Component({
        selector: 'unauthorized-component',
        templateUrl: './unauthorized.component.html'
    }),
    __metadata("design:paramtypes", [AuthService,
        ActivatedRoute,
        Router])
], UnauthorizedComponent);
export { UnauthorizedComponent };
//# sourceMappingURL=unauthorized.component.js.map