package dmp.javascript;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.Reader;

import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

public class JSEngine {

	private ScriptEngine engine;
	
	
	public JSEngine() {
		try {
			engine = new ScriptEngineManager().getEngineByName("nashorn");
		}
		catch(Exception ex) {
			engine = new ScriptEngineManager().getEngineByName("JavaScript");
		}
	}
	
	public void addScript(String script) throws ScriptException {
		engine.eval(script);
	}
	
	public void addScript(Reader script) throws ScriptException, FileNotFoundException {
		engine.eval(script);
	}
	
	public Object executeFunction(String functionName, Object ... args ) throws NoSuchMethodException, ScriptException {
		 return ((Invocable) engine).invokeFunction(functionName, args);
	}
	
}
